PlatformIO Community

Develop for Raspberry PI

I like to develop code for my rasperry pi. I normally develop arduino code with platformio on my iMAC what is fine. Now triying to open a project for the raspberry pi but get a message cross development not supportet. So i installed platformio on the raspberry successful. But the seams to be only a CLI. An other suggested solution was remote development. Can anyone give me hint how to manage this or a link to the doc where this is discribed. I also have I Linux box would there be a cross development possible,
Thanks a lot for help
Here https://docs.platformio.org/en/latest/boards/linux_arm/raspberrypi_2b.html?highlight=raspberry#raspberry-pi-2-model-b ist noted that it should work. Installing the remote agent on my PI latest OS fails

I was able to run the VSCode GUI on my Rasbpi with no problems at all. Also CodeBlocks runs on it which is supported as an IDE.

Documentation on PIO Remote Development is there.

Though you might also be interested in other solutions like CLion + Remote Development with Pi, might get better performance in this case…

Thanks
to the first answer: I do not have a gui on the PI nor a monitor. I work remote via SSH, I used Geany till now, which works fine in an X-Window on my MAC

to the second answer: I found that but as I wrote “platformio remote agent start” fails to install. Rasbian Buster with latest updates, platformio latest version.

Will checj CLion
Thanks Rainer

Do you have an exact error message?

yes here it si

Command "/usr/bin/python3 -m pip install --ignore-installed --no-user --prefix /tmp/pip-build-env-7_it1qok --no-warn-script-location --no-binary :all: --only-binary :none: -i https://pypi.org/simple --extra-index-url https://www.piwheels.org/simple -- setuptools>=40.6.0 wheel "cffi>=1.8,!=1.11.3; platform_python_implementation != 'PyPy'"" failed with error code 1 in None
Error: Traceback (most recent call last):
  File "/usr/local/lib/python3.7/dist-packages/platformio/package/manager/core.py", line 88, in inject_contrib_pysite
    from OpenSSL import SSL
  File "/root/.platformio/packages/contrib-pysite/OpenSSL/__init__.py", line 8, in <module>
  File "/root/.platformio/packages/contrib-pysite/OpenSSL/crypto.py", line 12, in <module>
  File "/root/.platformio/packages/contrib-pysite/cryptography/x509/__init__.py", line 8, in <module>
  File "/root/.platformio/packages/contrib-pysite/cryptography/x509/base.py", line 18, in <module>
  File "/root/.platformio/packages/contrib-pysite/cryptography/x509/extensions.py", line 20, in <module>
  File "/root/.platformio/packages/contrib-pysite/cryptography/hazmat/primitives/constant_time.py", line 11, in <module>
ImportError: /root/.platformio/packages/contrib-pysite/cryptography/hazmat/bindings/_constant_time.abi3.so: cannot open shared object file: No such file or directory

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/usr/local/lib/python3.7/dist-packages/platformio/__main__.py", line 109, in main
    cli()  # pylint: disable=no-value-for-parameter
  File "/usr/local/lib/python3.7/dist-packages/click/core.py", line 829, in __call__
    return self.main(*args, **kwargs)
  File "/usr/local/lib/python3.7/dist-packages/click/core.py", line 782, in main
    rv = self.invoke(ctx)
  File "/usr/local/lib/python3.7/dist-packages/platformio/commands/__init__.py", line 44, in invoke
    return super(PlatformioCLI, self).invoke(ctx)
  File "/usr/local/lib/python3.7/dist-packages/click/core.py", line 1259, in invoke
    return _process_result(sub_ctx.command.invoke(sub_ctx))
  File "/usr/local/lib/python3.7/dist-packages/click/core.py", line 1256, in invoke
    Command.invoke(self, ctx)
  File "/usr/local/lib/python3.7/dist-packages/click/core.py", line 1066, in invoke
    return ctx.invoke(self.callback, **ctx.params)
  File "/usr/local/lib/python3.7/dist-packages/click/core.py", line 610, in invoke
    return callback(*args, **kwargs)
  File "/usr/local/lib/python3.7/dist-packages/click/decorators.py", line 21, in new_func
    return f(get_current_context(), *args, **kwargs)
  File "/usr/local/lib/python3.7/dist-packages/platformio/commands/remote/command.py", line 48, in cli
    inject_contrib_pysite(verify_openssl=True)
  File "/usr/local/lib/python3.7/dist-packages/platformio/package/manager/core.py", line 90, in inject_contrib_pysite
    build_contrib_pysite_deps(get_core_package_dir("contrib-pysite"))
  File "/usr/local/lib/python3.7/dist-packages/platformio/package/manager/core.py", line 115, in build_contrib_pysite_deps
    dep,
  File "/usr/lib/python3.7/subprocess.py", line 347, in check_call
    raise CalledProcessError(retcode, cmd)
subprocess.CalledProcessError: Command '['/usr/bin/python3', '-m', 'pip', 'install', '--no-compile', '--no-binary', ':all:', '-t', '/root/.platformio/packages/contrib-pysite', 'autobahn == 20.4.3']' returned non-zero exit status 1.

============================================================

An unexpected error occurred. Further steps:

* Verify that you have the latest version of PlatformIO using
  `pip install -U platformio` command

* Try to find answer in FAQ Troubleshooting section
  https://docs.platformio.org/page/faq.html

* Report this problem to the developers
  https://github.com/platformio/platformio-core/issues

============================================================

pi@CAN-B:~ $

Your Pi is missing a library. Please upgrade the core (pio upgrade --dev) and install libssl-dev as per https://github.com/platformio/platformio-core/issues/3482.

Thanks for help
Did recomended actions
Double checked

pi@CAN-B:~ $ sudo pio upgrade --dev
Please wait while upgrading PlatformIO …
PlatformIO has been successfully upgraded to 5.0.2b2
Release notes: https://docs.platformio.org/en/latest/history.html
pi@CAN-B:~ $ sudo apt install libssl-dev
Reading package lists… Done
Building dependency tree
Reading state information… Done
libssl-dev is already the newest version (1.1.1d-0+deb10u3+rpt1).
0 upgraded, 0 newly installed, 0 to remove and 0 not upgraded.

Still Error

  compilation terminated.
  error: command 'arm-linux-gnueabihf-gcc' failed with exit status 1

  ----------------------------------------

Command “/usr/bin/python3 -u -c “import setuptools, tokenize;file=’/tmp/pip-install-91n11jin/cffi/setup.py’;f=getattr(tokenize, ‘open’, open)(file);code=f.read().replace(’\r\n’, ‘\n’);f.close();exec(compile(code, file, ‘exec’))” install --record /tmp/pip-record-hpv2e8r1/install-record.txt --single-version-externally-managed --prefix /tmp/pip-build-env-pqtwuhkh --compile” failed with error code 1 in /tmp/pip-install-91n11jin/cffi/

Right, there are still libs missing. I’ve just seen the tutorial HowTo: Raspberry Pi 3 as remote agent (Oct. 2020) being posted, which should be exactly what you need. Let me know if there are errors.

Thank you very much, that was the trick.
I followed the linked tutorial, the only thing additionally installed was “libffi-dev”
Now the installation runs through without errors
Rainer